Imports Microsoft.VisualBasic
Imports System
Imports System.Data
Imports System.Configuration
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Web.UI.HtmlControls
Imports System.Drawing
Imports Syncfusion.Windows.Forms.Diagram
Imports Syncfusion.Web.UI.WebControls.Diagram

Partial Public Class Diagram
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim nd1 As Node
        Dim nd2 As Node
        Dim nd3 As Node
        Dim nd4 As Node

        If Not IsPostBack Then
            nd1 = LoadNode(50, 50, "Node 1")
            nd2 = LoadNode(50, 100, "Node 2")
            nd3 = LoadNode(50, 150, "Node 3")
            nd4 = LoadNode(50, 200, "Node 4")
            DoLinkBetweenNodes(nd1, nd2)
            DoLinkBetweenNodes(nd2, nd3)
            DoLinkBetweenNodes(nd3, nd4)
        End If
    End Sub

    Private Function LoadNode(ByVal nX As Integer, ByVal nY As Integer, ByVal nDesc As String) As Syncfusion.Windows.Forms.Diagram.RoundRect
        Dim nodeRect As Syncfusion.Windows.Forms.Diagram.RoundRect
        Dim lbl As Syncfusion.Windows.Forms.Diagram.Label

        nodeRect = New Syncfusion.Windows.Forms.Diagram.RoundRect(nX, nY, 50, 25, MeasureUnits.Pixel)
        Try
            nodeRect.FillStyle.Type = FillStyleType.LinearGradient
            nodeRect.FillStyle.GradientAngle = -89
            nodeRect.FillStyle.GradientCenter = 1
            nodeRect.FillStyle.ForeColor = Color.White
            nodeRect.FillStyle.Color = Color.Green
            lbl = New Syncfusion.Windows.Forms.Diagram.Label(nodeRect, nDesc)
            lbl.FontStyle.Family = "Arial"
            lbl.FontStyle.Size = 9
            lbl.FontStyle.Bold = True
            nodeRect.Labels.Add(lbl)
            webDiagram.Model.AppendChild(nodeRect)
        Catch ex As Exception

        End Try
        Return nodeRect
    End Function

    Private Sub DoLinkBetweenNodes(ByRef node1 As Node, ByRef node2 As Node)
        Dim lConn As LineConnector
        Dim decor As Decorator
        Dim endPoint As EndPoint

        'create link from node1 to node2
        Try
            node1.EnableCentralPort = True
            node2.EnableCentralPort = True

            lConn = New LineConnector(New PointF(1, 1), New PointF(2, 2))

            decor = lConn.HeadDecorator
            decor.DecoratorShape = DecoratorShape.FilledFancyArrow
            decor.FillStyle.Color = Color.Black

            webDiagram.Model.AppendChild(lConn)

            endPoint = Nothing

            endPoint = lConn.TailEndPoint
            node1.CentralPort.TryConnect(endPoint)

            endPoint = lConn.HeadEndPoint
            node2.CentralPort.TryConnect(endPoint)

        Catch ex As Exception

        End Try

    End Sub

End Class